#include <iostream>
#include <vector>
#include <queue>

using namespace std;

int n, m;
bool matrix [100][100];
vector < int > ln [100];

vector < pair < int, int > > last_marked_edges;

bool mark (int from, int to)
{
	bool visited [100];
	for (int i = 0 ; i < 100 ; i ++) visited [i] = false;
	queue < pair < int, vector < int > > > q;
	q.push ({from, {}});
	visited [from] = true;
	while (!q.empty ())
	{
		auto curr = q.front (); q.pop ();

		if (curr.first == to)
		{
			int prev = from;
			for (auto& x : curr.second)
			{
				last_marked_edges.push_back ({prev, x});
				matrix [prev][x] = false;
				matrix [x][prev] = false;
				prev = x;
			}
			return true;
		}

		for (auto& x : ln [curr.first])
		{
			if (not visited [x] and matrix [curr.first][x])
			{
				curr.second.push_back (x);
				q.push ({x, curr.second});
				visited [x] = true;
				curr.second.pop_back ();
			}
		}
	}
	return false;
}

void init_matrix (int a, int b)
{
	matrix [a][b] = true;
	matrix [b][a] = true;
}

void recover ();

void init (bool recover_it = true, int a = 0, int b = 0)
{
	cin >> a >> b;
	a --; b --;
	init_matrix (a, b);
	ln [a].push_back (b);
	ln [b].push_back (a);
	if (recover_it) recover ();
}

int ans_init = 0;
bool count_ans (bool init_it = false)
{
	bool new_paths = false;
	int ans = ans_init;
	for ( ; mark (0, n - 1) ; ans ++) { new_paths = true; }
	cout << ans << endl;
	if (init_it) ans_init = ans;
	if (init_it) last_marked_edges.clear ();
	return new_paths and not init_it;
}

void recover ()
{
	bool recovered = false;
	for (auto& x : last_marked_edges)
		init_matrix (x.first, x.second);	
}

int main()
{
	cin.tie(nullptr);
	ios::sync_with_stdio (false);

	cin >> n >> m;
	for (int i = 0 ; i < m ; i ++)
	{
		init (false);
	}
	int q;
	cin >> q;
	bool to_recover = false;
	for (int i = 0 ; i < q ; i ++)
	{
		to_recover = count_ans (i == 0);
		init (to_recover);
	}
	count_ans ();
}

