#include <iostream>
#include <vector>

using namespace std;

int n, m;

int row_length (int row)
{
	return (1 - row) * n + row * m;
}

int cu [2][50000];
int mode_cu [2][50000];

bool is_receiver_or_unknown (int a)
{
	return a % 2 == 0;
}

bool is_streamer_or_unknown (int a)
{
	return a < 2;
}

bool set (int row, int ind, int val = 1)
{
	//cout << "try set " << row + 1 << " " << ind + 1 << " to " << val << endl;
	if (val == 1) // set as streamer
	{
		if (is_receiver_or_unknown (mode_cu [1 - row][cu [row][ind]]))
		{
			//cout << "\tset " << row + 1 << " " << ind + 1 << " to " << val << endl;
			//cout << "\tset " << 1 - row + 1 << " " << cu [row][ind] + 1 << " to " << 1 - val << endl;
			mode_cu [1 - row][cu [row][ind]] = 2;
			mode_cu [row][ind] = 1;
		}
		else
			throw "Can't stream to streamming devices.";
	}
	else // set as receiver
	{
		for (int i = 0 ; i < row_length (1 - row) ; i ++)
			if (cu [1 - row][i] == ind) // find a streamer to our device
			{
				if (is_streamer_or_unknown (mode_cu [1 - row][i])) // check if it is a streamer or an unknown device 
				{
					mode_cu [1 - row][i] = 1; // let it be streamer
				}
			}
		mode_cu [row][ind] = 2;
		// if there is not available streamer to this device it will be receiver because it will not change anything from result 'till that moment
	}
	return true;
}

int main()
{
	cin.tie(nullptr);
	ios::sync_with_stdio (false);
	cin >> n >> m;
	for (int i = 0 ; i < n ; i ++)
	{
		cin >> cu [0][i];
		cu [0][i] --;
	}
	for (int i = 0 ; i < m ; i ++)
	{
		cin >> cu [1][i];
		cu [1][i] --;
	}
	int row = 0;
	for (int i = 0 ; i < (1 - row) * n + row * m ; i ++)
		if (mode_cu [row][i] == 0)
		{
			try
			{
				bool result = set (row, i, 1);
			}
			catch (const char* error)
			{
				bool result = set (row, i, 0);
			}
			row = 1 - row;
			i = -1;
		}
Print: {
	for (int i = 0 ; i < n ; i ++)
		cout << mode_cu [0][i] % 2;
	cout << endl;
	for (int i = 0 ; i < m ; i ++)
		cout << mode_cu [1][i] % 2;
}
}

