#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

struct point
{
	int x, y;
};

vector < point > points;

int binary_search_by_x (int x, bool lower)
{
	point A = {x, 0};
	if (lower)
		return lower_bound (points.begin (), points.end (), A, [](point a, point b) { return a.x < b.x; }) - points.begin ();
	if (not lower)
		return upper_bound (points.begin (), points.end (), A, [](point a, point b) { return a.x < b.x; }) - points.begin ();
}

pair < int, int > possible (int x1, int x2)
{
	return {binary_search_by_x (x1, true), binary_search_by_x (x2, false)};
}

int analyze (pair < int, int > p, int y1, int y2)
{
	//cout << p.first << " " << p.second << endl;
	int ans = 0;
	for (int i = p.first ; i < p.second ; i ++)
		ans += (points [i].y >= y1 and points [i].y <= y2);
	return ans;
}

bool check (int i, int x1, int x2, int y1, int y2)
{
	return (
		x1 <= points [i].x and points [i].x <= x2 and
		y1 <= points [i].y and points [i].y <= y2
	);
}

int main ()
{
	cin.tie (nullptr);
	ios::sync_with_stdio (false);
	int n;
	cin >> n;
	for (int i = 0 ; i < n ; i ++)
	{
		int x, y;
		cin >> x >> y;
		points.push_back ({x, y});
	}
	
	sort (points.begin (), points.end (), [](point a, point b) { return a.x < b.x or (a.x == b.x and a.y < b.y); });

	int m;
	cin >> m;
	
	for (int i = 0 ; i < m ; i ++)
	{
		int x1, x2, y1, y2;
		cin >> x1 >> y1 >> x2 >> y2;
		int x_min = min (x1, x2), y_min = min(y1, y2);
		x2 = x1 + x2 - x_min; x1 = x_min;
		y2 = y1 + y2 - y_min; y1 = y_min;
		//int ans = 0;
		//for (int j = 0 ; j < points.size () ; j ++)
		//	ans += (check (j, x1, x2, y1, y2));
		cout << analyze (possible (x1, x2), y1, y2) << endl;
		//cout << ans << endl;
	}

}
