#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

struct Point
{
    int x;
    int y;
};

struct Rectangle
{
    int x;
    int y;
    int a;
    int b;
    int idx;
};

Point points[100005];
Rectangle rect[100005];
int res[100005];

bool cmpP (Point a, Point b)
{
    return a.x < b.x;
}

bool cmpR (Rectangle a, Rectangle b)
{
    return a.x < b.x;
}

int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int n, m;

    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> points[i].x >> points[i].y;
    }

    cin >> m;
    for (int i = 0; i < m; ++i)
    {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        rect[i].x = min(x1, x2);
        rect[i].y = min(y1, y2);
        rect[i].a = abs(x1 - x2);
        rect[i].b = abs(y1 - y2);
        rect[i].idx = i;
    }

    sort(points, points + n, cmpP);
    sort(rect, rect + m, cmpR);

    /*cout << "----------\n";
    for (int i = 0; i < n; ++i)
    {
        cout << i << " -> " << points[i].x << ' ' << points[i].y << '\n';
    }
    cout << "----------\n";
    for (int i = 0; i < m; ++i)
    {
        cout << i << " -> " << rect[i].x << ' ' << rect[i].y << ' ' << rect[i].a << ' ' << rect[i].b << " idx " << rect[i].idx << '\n';
    }
    cout << "----------\n";*/

    int start = 0;
    for (int i = 0; i < n; ++i)
    {
        while (rect[start].x + rect[start].a < points[i].x)
        {
            ++start;
        }
        for (int j = start; rect[j].x <= points[i].x and j < m; ++ j)
        {
            if (points[i].x <= rect[j].x + rect[j].a and rect[j].y <= points[i].y and points[i].y <= rect[j].y + rect[j].b)
            {
                res[rect[j].idx]++;
                //cout << i << ' ' << j << '\n';
            }
        }
    }

    for (int i = 0; i < m; ++i)
    {
        cout << res[i] << '\n';
    }

    return 0;
}
