#include <iostream>
#include <cmath>
#include <algorithm>

using namespace std;

struct Point
{
    int x;
    int y;
};

struct Rectangle
{
    int x;
    int y;
    int a;
    int b;
};

Point points[100005];
Rectangle rect[100005];

bool cmp (Point a, Point b)
{
    return a.x < b.x;
}

int main ()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int n, m;

    cin >> n;
    for (int i = 0; i < n; ++i)
    {
        cin >> points[i].x >> points[i].y;
    }

    cin >> m;
    for (int i = 0; i < m; ++i)
    {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        rect[i].x = min(x1, x2);
        rect[i].y = min(y1, y2);
        rect[i].a = abs(x1 - x2);
        rect[i].b = abs(y1 - y2);
    }

    sort(points, points + n, cmp);

    /*cout << "----------\n";
    for (int i = 0; i < n; ++i)
    {
        cout << i << " -> " << points[i].x << ' ' << points[i].y << '\n';
    }
    cout << "----------\n";
    for (int i = 0; i < m; ++i)
    {
        cout << i << " -> " << rect[i].x << ' ' << rect[i].y << ' ' << rect[i].a << ' ' << rect[i].b << '\n';
    }
    cout << "----------\n";*/

    for (int i = 0; i < m; ++i)
    {
        int f = 0, l = n - 1;
        while (f < l)
        {
            int midd = (f + l) / 2;
            if (points[midd].x < rect[i].x)
            {
                f = midd + 1;
            }
            else
            {
                l = midd - 1;
            }
        }

        int res = 0;
        for (; points[l].x <= rect[i].x + rect[i].a; ++l)
        {
            if (points[l].x >= rect[i].x and points[l].y >= rect[i].y and points[l].y <= rect[i].y + rect[i].b)
            {
                ++res;
            }
        }

        cout << res << '\n';
    }

    return 0;
}
