#include <iostream>
#include <cstdio>
#include <vector>
#include <queue>
using namespace std;

const int N=105;

struct Edge
{
 int from;
 int to;
 bool active;

  Edge(int _from,int _to,bool _active)
  {
   from=_from;
   to=_to;
   active=_active;
  }
};

vector <Edge> edges;
vector <int> g[N];
int n,m,iter;
int used[N],parent[N];
queue <int> q;

bool BFS(int v)
{
 int i,x,to;
 bool act;

  while(!q.empty())
   q.pop();

 q.push(1);
 iter++;
 used[1]=iter;
  while(!q.empty())
  {
   x=q.front();
   q.pop();

    for(i=0;i<g[x].size();i++)
    {
     to=edges[g[x][i]].to;
     act=edges[g[x][i]].active;

      if(used[to]!=iter && act)
      {
       parent[to]=g[x][i];
       used[to]=iter;
       q.push(to);

        if(to==n)
        {
          while(to!=1)
          {
           edges[parent[to]].active=false;
           edges[parent[to]^1].active=false;
           to=edges[parent[to]].from;
          }

         return true;
        }
      }
    }
  }

 return false;
}

int main()
{

int u,v,i,ans;

scanf("%d%d",&n,&m);

 for(i=1;i<=m;i++)
 {
  scanf("%d%d",&u,&v);

  g[u].push_back(edges.size());
  edges.push_back(Edge(u,v,true));

  g[v].push_back(edges.size());
  edges.push_back(Edge(v,u,true));
 }

ans=0;
 while(BFS(1))
 {
  ans++;
 }

printf("%d\n",ans);

scanf("%d",&q);

return 0;
}
