#include <bits/stdc++.h>

using namespace std;

const int MAXN = 101;
const int MAXE = 4955;
const int INF = 1e6;

struct Edge
{
    int to;
    int rd;
    int next;
    Edge(){};
    Edge(int _to, int _rd, int _next) : to(_to), rd(_rd), next(_next){};
};

int n, m;
int source, target;
int head[MAXN], bp;
Edge E[MAXE * 2];
int lvl[MAXN], ptr[MAXN];

void add_edge(int from, int to, int rd)
{
    E[bp] = Edge(to, rd, head[from]);
    head[from] = bp++;
}

void read_input()
{
    scanf("%d %d", &n, &m);

    for(int i = 0; i < n; i++)
    {
        head[i] = -1;
    }

    for(int i = 0; i < m; i++)
    {
        int v, w;
        scanf("%d %d", &v, &w);
        v--; w--;
        add_edge(v, w, 1);
        add_edge(w, v, 1);
    }
    source = 0;
    target = n - 1;
}

bool bfs()
{
    for(int i = 0; i < n; i++)
    {
        lvl[i] = -1;
    }
    queue <int> q;
    lvl[source] = 0;
    q.push(source);

    while(!q.empty())
    {
        int c = q.front(); q.pop();

        for(int e = head[c]; e != -1; e = E[e].next)
        {
            int to = E[e].to;
            if(E[e].rd > 0 && lvl[to] == -1)
            {
                lvl[to] = lvl[c] + 1;
                q.push(to);
            }
        }
    }

    return lvl[target] != -1;
}

int dfs(int v, int flow)
{
    if(v == target)
    {
        return flow;
    }
    for(int e = ptr[v]; e != -1; e = ptr[v] = E[e].next)
    {
        int to = E[e].to;
        if(E[e].rd > 0 && lvl[to] == lvl[v] + 1)
        {
            int aug_flow = dfs(to, min(flow, E[e].rd));
            if(aug_flow)
            {
                E[e].rd -= aug_flow;
                E[e ^ 1].rd += aug_flow;
                return aug_flow;
            }
        }
    }
    return 0;
}

int dinic()
{
    int ans = 0;
    while(bfs())
    {
        for(int i = 0; i < n; i++)
        {
            ptr[i] = head[i];
        }
        int delta = 0;
        do
        {
            delta = dfs(source, INF);
            ans += delta;
        }while(delta);
    }
    return ans;
}

int main()
{
    read_input();
    printf("%d\n", dinic());

    return 0;
}

/*
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
*/
