#include <bits/stdc++.h>

using namespace std;

const int MAXN = 101;
const int INF = 1e6;

int n, m;
int source, target;
int lvl[MAXN], ptr[MAXN];
int graph[MAXN][MAXN];
int graph2[MAXN][MAXN];

void read_input()
{
    scanf("%d %d", &n, &m);

    for(int i = 0; i < m; i++)
    {
        int v, w;
        scanf("%d %d", &v, &w);
        v--; w--;
        graph2[v][w]++;
        graph2[w][v]++;
    }
    source = 0;
    target = n - 1;
}

bool bfs()
{
    for(int i = 0; i < n; i++)
    {
        lvl[i] = -1;
    }
    queue <int> q;
    lvl[source] = 0;
    q.push(source);

    while(!q.empty())
    {
        int c = q.front(); q.pop();

        for(int i = 0; i < n; i++)
        {
            if(graph[c][i] > 0 && lvl[i] == -1)
            {
                lvl[i] = lvl[c] + 1;
                q.push(i);
            }
        }
    }

    return lvl[target] != -1;
}

int dfs(int v, int flow)
{
    if(v == target)
    {
        return flow;
    }
    for(int i = ptr[v]; i < n; i++, ptr[v]++)
    {
        if(graph[v][i]> 0 && lvl[i] == lvl[v] + 1)
        {
            int aug_flow = dfs(i, min(flow, graph[v][i]));
            if(aug_flow)
            {
                graph[v][i]--;
                graph[i][v]++;
                return aug_flow;
            }
        }
    }
    return 0;
}

int dinic()
{
    int ans = 0;
    while(bfs())
    {
        for(int i = 0; i < n; i++)
        {
            ptr[i] = i;
        }
        int delta = 0;
        do
        {
            delta = dfs(source, INF);
            ans += delta;
        }while(delta);
    }
    return ans;
}

void reset()
{
    for(int i = 0; i < n; i++)
    {
        for(int j = 0; j < n; j++)
        {
            graph[i][j] = graph2[i][j];
        }
    }
}

int main()
{
    read_input();
    int q;
    scanf("%d", &q);
    reset();
    printf("%d\n", dinic());
    for(int i = 0; i < q; i++)
    {
        int v, w;
        scanf("%d %d", &v, &w);
        v--; w--;
        graph2[v][w]++;
        graph2[w][v]++;
        reset();
        printf("%d\n", dinic());
    }

    return 0;
}

/*
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
0

5 5
1 2
3 5
5 4
1 5
3 2
0
*/

/*
5 4
1 2
3 5
5 4
1 5
3
3 2
1 3
2 5
*/
