#include<iostream>
#include<vector>
#define endl '\n'

using namespace std;

const int MAXN = 10000;
const int MAXM = 10000;
const int MAXX= 100000;
int n, m;
struct coordinates
{
    int x, y;
};
struct rectcoordinates
{
    coordinates l;
    coordinates r;
};
vector<coordinates> point;
vector<rectcoordinates> rect;
struct tree
{
    int key[2];
    vector<int> wh;
    int l, r;
};
vector<tree> tr;
int trsiz;
int beg;
int counter[MAXM+10];


void input()
{
    coordinates a, b;
    cin>>n;
    for (int i=0; i<n; i++)
    {
        cin>>a.x>>a.y;
        point.push_back(a);
    }
    cin>>m;
    for (int i=0; i<m; i++)
    {
        cin>>a.x>>a.y>>b.x>>b.y;
        if (a.x > b.x) swap(a.x, b.x);
        if (a.y > b.y) swap(a.y, b.y);
        rect.push_back({a, b});
    }
}

void output()
{
    for (int i=0; i<m; i++)
    {
        cout<<counter[i]<<endl;
    }
}

void AddLeaf(int cur, int x, int y, int i)
{
    //cerr<<x<<' '<<y<<endl;
    if (cur < 0) return;
    if (x >= tr[cur].key[0] && y <= tr[cur].key[1])
    {
        if (x > tr[cur].key[0])
        {
            tr.push_back(tr[cur]);
            tr[cur].l = trsiz;
            tr[cur].key[0] = x;
            tr[trsiz].key[1] = x-1;
            tr[trsiz++].r = -1;
        }
        if (y < tr[cur].key[1])
        {
            tr.push_back(tr[cur]);
            tr[cur].r = trsiz;
            tr[cur].key[1] = y;
            tr[trsiz].key[0] = y+1;
            tr[trsiz++].l = -1;
        }
        tr[cur].wh.push_back(i);
    }
    else
    {
        if (x < tr[cur].key[0] && y > tr[cur].key[1])
        {
            AddLeaf(cur, x, tr[cur].key[0]-1, i);
            AddLeaf(cur, tr[cur].key[0], tr[cur].key[1], i);
            AddLeaf(cur, tr[cur].key[1]+1, y, i);
        }
        else
        {
            if (x <= tr[cur].key[0] && y >= tr[cur].key[0])
            {
                AddLeaf(cur, tr[cur].key[0], y, i);
                AddLeaf(cur, tr[cur].key[0], tr[cur].key[1], i);
                AddLeaf(cur, x, tr[cur].key[0]-1, i);
            }
            else if (x <= tr[cur].key[0] && y <= tr[cur].key[0])
            {
                if (tr[cur].l > -1) AddLeaf(tr[cur].l, x, y, i);
                else
                {
                    tree temp;
                    temp.key[0] = x;
                    temp.key[1] = y;
                    temp.l = -1;
                    temp.r = -1;
                    temp.wh.push_back(i);
                    tr.push_back(temp);
                    tr[cur].l = trsiz++;
                }
            }
            else if (x <= tr[cur].key[1] && y >= tr[cur].key[1])
            {
                AddLeaf(cur, x, tr[cur].key[1], i);
                AddLeaf(cur, tr[cur].key[1]+1, y, i);
            }
            else if (x >= tr[cur].key[1] && y >= tr[cur].key[1])
            {
                if (tr[cur].r > -1) AddLeaf(tr[cur].r, x, y, i);
                else
                {
                    tree temp;
                    temp.key[0] = x;
                    temp.key[1] = y;
                    temp.l = -1;
                    temp.r = -1;
                    temp.wh.push_back(i);
                    tr.push_back(temp);
                    tr[cur].r = trsiz++;
                }
            }
        }
    }
}

void MakeTree()
{
    beg = 0;
    tree temp;
    temp.key[0] = rect[0].l.x;
    temp.key[1] = rect[0].r.x;
    temp.l = -1;
    temp.r = -1;
    temp.wh.push_back(0);
    tr.push_back(temp);
    trsiz++;
    for (int i=1; i<m; i++)
    {
        AddLeaf(beg, rect[i].l.x, rect[i].r.x, i);
    }
}

int FindPoint(int cur, int pr)
{
    if (cur < 0) return trsiz;
    if (tr[cur].key[0] >= pr && tr[cur].key[1] <= pr) return cur;
    else if (pr < tr[cur].key[0])
    {
        if (tr[cur].l > -1) return FindPoint(tr[cur].l, pr);
        else return trsiz;
    }
    else if (pr > tr[cur].key[1])
    {
        if (tr[cur].r > -1) return FindPoint(tr[cur].r, pr);
        else return trsiz;
    }
}

void CountPoints()
{
    int temp = 0;
    for (int i=0; i<n; i++)
    {
        temp = FindPoint(beg, point[i].x);
        if (temp < trsiz)
        {
            for (int j=0; j<tr[temp].wh.size(); j++)
            {
                if (rect[tr[temp].wh[j]].l.y <= point[i].y && rect[tr[temp].wh[j]].r.y >= point[i].y) counter[tr[temp].wh[j]]++;
            }
        }
    }
}

void solve()
{
    MakeTree();
    CountPoints();
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    input();
    solve();
    output();
    return 0;
}

/*
6
9 2
2 3
8 6
3 6
5 3
5 8
3
6 9 9 8
2 3 5 8
10 7 4 3

5
2 9
2 8
2 7
2 6
2 5
4
2 2 9 9
2 7 2 8
3 1 3 10
0 0 2 5
*/

