#include<iostream>
#include<cmath>
#include<map>
#include<set>
#include<algorithm>

using namespace std;

const int MAXN = 1e5 + 5;

struct object
{
    bool type, side;
    int x, y;

    int length, index;
};

//point false
//rect true

int n, m;
object a[MAXN*5];

int tree[12*MAXN], lazy[12*MAXN];

set <int> Ys;
bool flag = false;

int number = 0;
map <int, int> code;

int answer[MAXN];
int found[MAXN];

void updateLazy(int l, int r, int index)
{
    tree[index] += lazy[index]*(r-l+1);
    if(l!=r)
    {
        lazy[2*index] += lazy[index];
        lazy[2*index+1] += lazy[index];
    }

    lazy[index] = 0;
}

void updateTree(int l, int r, int ql, int qr, int index, int value)
{
    updateLazy(l, r, index);
    //cout << l << " " << r << " || " << index << '\n';

    if(l>=ql && r<=qr)
    {
        tree[index] += (r-l+1)*value;
        if(l!=r)
        {
            lazy[2*index] += value;
            lazy[2*index+1] += value;
        }

        return;
    }
    if(r<ql || l>qr) return;

    updateTree(l, (l+r)/2, ql, qr, 2*index, value);
    updateTree((l+r)/2+1, r, ql, qr, 2*index+1, value);

    tree[index] = tree[2*index] + tree[2*index+1];
}

int queryTree(int l, int r, int ql, int qr, int index)
{
    updateLazy(l, r, index);

    if(l>=ql && r<=qr) return tree[index];
    if(r<ql || l>qr) return 0;

    return queryTree(l, (l+r)/2, ql, qr, 2*index) + queryTree((l+r)/2+1, r, ql, qr, 2*index+1);
}

int encode(int y)
{
    if(code.count(y)==false)
    {
        code[y] = number;
        number++;

        //cout << "OK" << '\n';
        return number - 1;
    }

    return code[y];
}

bool operator <(const object A, const object B)
{
    if(A.x!=B.x) return A.x<B.x;
    if(A.type!=B.type)
    {
        if(A.type==false && B.side==false) return false;
        if(A.type==false && B.side==true) return true;

        if(A.type==true && A.side==false) return true;
        if(A.type==true && A.side==true) return false;
    }

    if(A.side!=B.side) return A.side<B.side;
    if(A.length!=B.length) return A.length<B.length;
    if(A.y!=B.y) return A.y<B.y;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int index;
    int x, y, length;

    int value;

    cin >> n;index = n;
    for(int i = 0;i<n;i++)
    {
        cin >> a[i].x >> a[i].y;
        a[i].type = false;

        Ys.insert(a[i].y);
    }

    cin >> m;
    for(int i = 0;i<m;i++)
    {
        cin >> a[index].x >> a[index].y;
        a[index].type = true;

        cin >> x >> y;
        length = abs(a[index].y-y);

        Ys.insert(a[index].y);
        Ys.insert(y);

        a[index].length = length;
        a[index].side = false;
        a[index].index = i;
        index++;

        a[index].x = x;
        a[index].y = y;
        a[index].type = true;
        a[index].side = true;
        a[index].length = length;
        a[index].index = i;

        if(a[index-1].x>a[index].x) swap(a[index-1].x, a[index].x);
        if(a[index-1].y>a[index].y) swap(a[index-1].y, a[index].y);

        index++;
    }

    for(auto it = Ys.begin();it!=Ys.end();it++)
    {
        encode(*it);
    }
    flag = true;

    //cout << "----" << '\n';

    sort(a, a+index);
    for(int i = 0;i<index;i++)
    {
        if(a[i].type==false)
        {
            //cout << "point: " << a[i].x << " " << a[i].y << '\n';
           updateTree(0, number, encode(a[i].y), encode(a[i].y), 1, 1);

        }
        else
        {
            if(a[i].side==true)
            {
                //cout << "true: " << a[i].y - a[i].length << " " << a[i].y << '\n';
                answer[ a[i].index ] = queryTree(0, number, encode(a[i].y-a[i].length), encode(a[i].y), 1);
            }
            else if(a[i].side==false)
            {
                //cout << "false: " << a[i].y  << " " << a[i].y + a[i].length << '\n';
                found[ a[i].index ] = queryTree(0, number, encode(a[i].y), encode(a[i].y+a[i].length), 1);
            }

        }
    }

    for(int i = 0;i<m;i++)
        cout << answer[i] - found[i]  << '\n';
}
/*
6
9 2
2 3
8 6
3 6
5 3
5 8
3
6 9
9 8
2 3 5 8
10 7
4 3
*/
