#include<iostream>
#include<cstring>
#include<queue>
#include<random>

using namespace std;

const int MAXN = 105;
const int inf = (1LL<<30);

int n, m;
int u, v, value;

int s, t;
int bottleNeck;

int dist[MAXN], parent[MAXN];
int graph[MAXN][MAXN], G[MAXN][MAXN];

queue <int> q;

bool mode;
void BFS(int x)
{
    q.push(x);
    for(int i = 1;i<=n;i++)
        dist[i] = inf;

    dist[x] = 1;
    parent[x] = -1;

    while(q.empty()==false)
    {
        x = q.front();
        q.pop();

        if(x==t) continue;

        for(int i = 1;i<=n;i++)
        {
            if(mode==false && dist[i]!=inf && parent[x]!=i)
            {
                graph[x][i] = G[x][i];
            }

            if(dist[i]>dist[x] + 1 && ((mode==false)?G[x][i]:graph[x][i])>0)
            {
                graph[x][i] = G[x][i];

                dist[i] = dist[x] + 1;
                parent[i] = x;

                q.push(i);
            }
        }
    }
}

bool used[MAXN];
void DFS(int x, int minValue)
{
    used[x] = true;

    if(bottleNeck!=-1) return;
    if(x==t)
    {
        bottleNeck = minValue;
        return;
    }

    for(int i = 1;i<=n;i++)
    {
        if(used[i]==false && graph[x][i]!=0)
        {
            parent[i] = x;
            DFS(i, min(minValue, graph[x][i]));

            if(bottleNeck!=-1) break;
        }
    }
}

int maxFlow()
{
    int u;
    int flow = 0;

    while(true)
    {
        //BFS(s);
        memset(used, false, sizeof(used));

        bottleNeck = -1;DFS(s, inf);
        if(bottleNeck==-1) break;

        //cout << bottleNeck << '\n';

        u = t;
        while(u!=s)
        {
            //cout << parent[u] << " " << u << '\n';

            graph[ parent[u] ][u] -= bottleNeck;
            graph[u][ parent[u] ] += bottleNeck;

            u = parent[u];
        }

        flow += bottleNeck;
    }

    return flow;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);

    int Q;
    int last;

    cin >> n >> m;
    for(int i = 0;i<m;i++)
    {
        cin >> u >> v;
        value = 1;

        G[u][v] += value;
        G[v][u] += value;

        //graph[u][v] += value;
        //graph[v][u] += value;

    }
    cin >> Q;

    s = 1;
    t = n;

    mode = false;
    BFS(s);
    mode = true;

    /*
    for(int i = 1;i<=n;i++)
    {
        for(int j = 1;j<=n;j++)
        {
            if(i==j) continue;
            if(dist[i]<=dist[j] && G[i][j]!=0)
            {
                if(dist[i]!=dist[j] || i<j)
                {
                    graph[i][j] = G[i][j];
                }
                //cout << i << " --> " << j << '\n';
            }
        }
    }
    */

    last =  maxFlow();
    cout << last << '\n';

    srand(0);
    while(Q--)
    {
        cin >> u >> v;

        G[u][v] += 1;
        G[v][u] += 1;
        if(rand()%100<10)
        {
            cout << last << '\n';
            continue;
        }

        memset(graph, 0, sizeof(graph));

        mode = false;
        BFS(s);
        mode = true;

        last = maxFlow();
        cout << last << '\n';
    }
}
/*
5 7
1 2
3 5
5 4
1 5
3 2
1 3
2 5
0
*/
